--------------------------------------------------------------------------------
--Options
--------------------------------------------------------------------------------
local ChargeSortedBank = Apollo.GetAddon("ChargeSortedBank")

  local Designs = {
   [1] = "AbilitiesSprites:spr_StatVertProgBase",
   [2] = "CRB_Basekit:kitScrollbase_Horiz_HoloSmall",
   [3] = "CRB_DEMO_CreationSprites:sprDemo_CCFrameBG",
   [4] = "CRB_MegamapSprites:sprMap_WorldMap",
   [5] = "CRB_TooltipSprites:sprTT_BasicBack",
   [6] = "charactercreate:sprCharC_BG02",

  }
---------------------------------------------------------------------------------------------------
-- Options Functions
---------------------------------------------------------------------------------------------------

function ChargeSortedBank:LoadOptions()
	local mainOptWnd = self.wndOptions:FindChild("OptionsDialogueControls")
	local list = self.wndOptions:FindChild("ListControls")
	mainOptWnd:DestroyChildren()
	list:DestroyChildren()

	for i,j in pairs(self.db.profile.general.optionsList) do
		local newOpt = Apollo.LoadForm(self.xmlDoc, "OptionsListItem", list, self)
		newOpt:SetText(i)
	end
	list:ArrangeChildrenVert(0)
end

function ChargeSortedBank:OnOptionsListClick( wndHandler, wndControl, eMouseButton )
	local OptionsName = wndControl:GetText()

	local mainOptWnd = self.wndOptions:FindChild("OptionsDialogueControls")
	mainOptWnd:DestroyChildren()
	local CurOptWnd = Apollo.LoadForm(self.xmlDoc, OptionsName.."Option", mainOptWnd, self)
	self:SetOptions(CurOptWnd)
end

function ChargeSortedBank:SetOptions(CurOptWnd)
	local Name = CurOptWnd:GetName()
	local Opt = self.db.profile.general.optionsList
	if Name == "GeneralOption" then
		CurOptWnd:FindChild("Scale_IconSize"):FindChild("EditBox"):SetText(tostring(Opt.General.knSizeIconOption))
		local min, max , tick = 35,60,5
		local sliderIconSize = CurOptWnd:FindChild("Scale_IconSize"):FindChild("SliderBar")
		sliderIconSize:SetMinMax(min,max,tick)
		sliderIconSize:SetValue(Opt.General.knSizeIconOption)

  elseif Name == "DesignOption" then
    --Opacity
    CurOptWnd:FindChild("Scale_Opacity"):FindChild("EditBox"):SetText(tostring(Opt.Design.fOpacity))
    local min, max , tick = 0, 1, 0.01
    local slider = CurOptWnd:FindChild("Scale_Opacity"):FindChild("SliderBar")
    slider:SetMinMax(min,max,tick)
		slider:SetValue(Opt.Design.fOpacity)

    --BGDesign
    CurOptWnd:FindChild("Scale_BGDesign"):FindChild("EditBox"):SetText(tostring(Opt.Design.BG))
    local min, max , tick = 0, 6, 1
    local slider2 = CurOptWnd:FindChild("Scale_BGDesign"):FindChild("SliderBar")
    slider2:SetMinMax(min,max,tick)
		slider2:SetValue(Opt.Design.BG)

    --Color
    CurOptWnd:FindChild("Swatch"):SetBGColor(self.db.profile.general.optionsList.Design.BGColor)
	end
end

function ChargeSortedBank:SaveOptions( wndHandler, wndControl, eMouseButton )
	local main = wndControl:GetParent():GetParent()
	local name = main:GetName()

	if name == "GeneralOption" then
		option = self.db.profile.general.optionsList.General
		option.knSizeIconOption = tonumber(main:FindChild("Scale_IconSize"):FindChild("EditBox"):GetText())
	end
end

function ChargeSortedBank:OnIconSizeSlideChanged( wndHandler, wndControl, fNewValue, fOldValue )
	local EditBox = wndControl:GetParent():FindChild("EditBox")
	local NewValue = math.ceil(fNewValue)
	EditBox:SetText(tostring(NewValue))
	self.db.profile.general.optionsList.General.knSizeIconOption = NewValue
	self:UpdateSize()
	self:ArrangeChildren()
end

function ChargeSortedBank:OnOpacitySlideChanged( wndHandler, wndControl, fNewValue, fOldValue )
	local EditBox = wndControl:GetParent():FindChild("EditBox")
	local NewValue = math.ceil(fNewValue*100)/100
	EditBox:SetText(tostring(NewValue))
	self.db.profile.general.optionsList.Design.fOpacity = NewValue
  self.wndMain:FindChild("BG"):SetOpacity(NewValue)
end

function ChargeSortedBank:OnDesignSlideChanged( wndHandler, wndControl, fNewValue, fOldValue )
	local EditBox = wndControl:GetParent():FindChild("EditBox")
	local NewValue = math.ceil(fNewValue)
	EditBox:SetText(tostring(NewValue))
	self.db.profile.general.optionsList.Design.BG = NewValue
  self.wndMain:FindChild("BG"):SetSprite(Designs[NewValue])
end

function ChargeSortedBank:OnMainDesignSlideChanged( wndHandler, wndControl, fNewValue, fOldValue )
	local EditBox = wndControl:GetParent():FindChild("EditBox")
	local NewValue = math.ceil(fNewValue)
	EditBox:SetText(tostring(NewValue))
	self.db.profile.general.optionsList.Design.Main = NewValue
  self.wndMain:Destroy()
  self.wndMain = 	Apollo.LoadForm(self.xmlDoc, "InventoryBag_"..tostring(self.db.profile.general.optionsList.Design.Main), nil, self)
  self.OneSlot = self.wndMain:FindChild("OneBagSlot")
  self.RealBag = self.OneSlot:FindChild("RealBagWindow")
  self:SetWindows()
  self:LoadGrid()
  self:LoadSlots()
  if self.RealBag:GetTotalEmptyBagSlots() == 0 then
      self.wndMain:FindChild("Border"):Show(true)
      self.wndMain:FindChild("Full"):SetText("full")
  end
  self:LoadGrid()
  self:ArrangeChildren()
  self.wndMain:Show(true)
end
---------------------------------------------------------------------------------------------------
-- ColorPickerCallback
---------------------------------------------------------------------------------------------------
function ChargeSortedBank:ColorPickerCallback(strColor)
	self.wndOptions:FindChild("OptionsDialogueControls"):FindChild("Swatch"):SetBGColor(strColor)
	self.db.profile.general.optionsList.Design.BGColor = strColor
 	self.wndMain:FindChild("BG"):SetBGColor(self.db.profile.general.optionsList.Design.BGColor)
end
function ChargeSortedBank:OnColor( wndHandler, wndControl, eMouseButton )
	self.colorPicker:Show(true)
	self.colorPicker:ToFront()
end
