--------------------------------------------------------------------------------------------
--Window Management
---------------------------------------------------------------------------------------------
local ChargeSortedBank = Apollo.GetAddon("ChargeSortedBank")

local Qualitys = {
	[1] = "BK3:UI_BK3_ItemQualityGrey",
	[2] = "BK3:UI_BK3_ItemQualityWhite",
	[3] = "BK3:UI_BK3_ItemQualityGreen",
	[4] = "BK3:UI_BK3_ItemQualityBlue",
	[5] = "BK3:UI_BK3_ItemQualityPurple",
	[6] = "BK3:UI_BK3_ItemQualityOrange",
	[7] = "BK3:UI_BK3_ItemQualityMagenta",
	}

  local Designs = {
   [1] = "AbilitiesSprites:spr_StatVertProgBase",
   [2] = "CRB_Basekit:kitScrollbase_Horiz_HoloSmall",
   [3] = "CRB_DEMO_CreationSprites:sprDemo_CCFrameBG",
   [4] = "CRB_MegamapSprites:sprMap_WorldMap",
   [5] = "CRB_TooltipSprites:sprTT_BasicBack",
   [6] = "charactercreate:sprCharC_BG02",

  }

local NumberQualitys = {
	[1] = "darkgray",
	[2] = "UI_WindowTextDefault",
	[3] = "AddonOk",
	[4] = "xkcdBrightBlue",
	[5] = "xkcdBarney",
	[6] = "Amber",
	[7] = "magenta",
	}

--compare Function
local fnSortItemsByName = function(itemLeft, itemRight)
	local strLeftName = itemLeft:GetName()
	local strRightName = itemRight:GetName()
	return strLeftName > strRightName
end

local fnSortItemsBylvl = function(itemLeft, itemRight)
	if itemLeft == itemRight then
		return 0
	end
	if itemLeft and itemRight == nil then
		return -1
	end
	if itemLeft == nil and itemRight then
		return 1
	end
	local leftilvl = itemLeft:GetDetailedInfo()["tPrimary"]["nItemLevel"]
	local rightilvl = itemRight:GetDetailedInfo()["tPrimary"]["nItemLevel"]
	if leftilvl < rightilvl then
		return -1
	end
	if leftilvl > rightilvl then
		return 1
	end

	return 0
end

local fnSortBagBySize = function(BagLeft, BagRight)
	local left = BagLeft:FindChild("BagGrid"):GetChildren()
	local right = BagLeft:FindChild("BagGrid"):GetChildren()

	return (#left) > (#right)
end
-----------------------------------------------------------------------------------------------
-- Window Controls
-----------------------------------------------------------------------------------------------



function ChargeSortedBank:ArrangeChildren()
	local Options = self.db.profile.general.optionsList.General
	local titleHeight = 35
	local compensate = 16 --Since ArrangeChilderenTile() cuts off Tiles even before the max width is reached the Window needs to wider than columns*IconSize (therefor compensate)
	local BordersWidth = 61
	local smallBorder = Options.knSizeIconOption -10 -- The value needs to be smaller than the cube "-10" is best fitting
	local BagGrid = self.wndMain:FindChild("BagGrid")
	local Bags = BagGrid:GetChildren()

	table.sort(Bags, fnSortBagBySize)

	local a,b,c,d = self.wndMain:GetAnchorOffsets()
	local Width = c-a
	local LeftSlots = {}
	LeftSlots[1] = {0, 0 , 0 , 0}
	local counter = 1

	for i,j in pairs(Bags) do
		local Bag = j
		local slots = Bag:FindChild("BagGrid"):GetChildren()
		local slotsPerRow = math.floor((Options.knBagsWidth-BordersWidth)/Options.knSizeIconOption)
		if #slots >= slotsPerRow then
			local rows = math.ceil(#slots/slotsPerRow)
			counter = counter + 1
			LeftSlots[counter] = {LeftSlots[counter-1][1], LeftSlots[counter-1][4], LeftSlots[counter-1][1] + Options.knBagsWidth - BordersWidth + compensate,
				LeftSlots[counter-1][4]+ rows*Options.knSizeIconOption + titleHeight}
			Bag:SetAnchorOffsets( LeftSlots[counter-1][1], LeftSlots[counter-1][4], LeftSlots[counter-1][1] + Options.knBagsWidth - BordersWidth + compensate,
				LeftSlots[counter-1][4]+ rows*Options.knSizeIconOption + titleHeight)
		else
			local newHome = false
			for i,j in pairs(LeftSlots) do
				if i ~= 1 and newHome == false then
					local newWidth = j[3]+ #slots*Options.knSizeIconOption
					if (newWidth < Options.knBagsWidth-BordersWidth) then
						Bag:SetAnchorOffsets( j[3], j[2],newWidth+smallBorder,j[4])
						LeftSlots[i] = {j[1], j[2],newWidth+smallBorder,j[4]}
						newHome = true
					end
				end
			end
			if newHome == false then
				counter = counter +1
				local newWidth = LeftSlots[counter-1][1]+ #slots*Options.knSizeIconOption+smallBorder
				LeftSlots[counter] = {LeftSlots[counter-1][1],LeftSlots[counter-1][4], newWidth,LeftSlots[counter-1][4]+ Options.knSizeIconOption + titleHeight}
				Bag:SetAnchorOffsets(LeftSlots[counter-1][1], LeftSlots[counter-1][4], newWidth,LeftSlots[counter-1][4]+ Options.knSizeIconOption + titleHeight)
			end
		end
		Bag:FindChild("BagGrid"):ArrangeChildrenTiles(0)
	end
end




function ChargeSortedBank:SetWindows()
	local l , t, r, b = unpack(self.db.profile.general.tAnchorOffsetBank)
	self.wndMain:SetAnchorOffsets(l , t, r, b)
	local l2, t2, r2, b2 = unpack(self.db.profile.general.tAnchorOffsetOpt)
	self.wndOptions:SetAnchorOffsets(l2, t2, r2, b2)

  local BG = self.wndMain:FindChild("BG")
  --Background
  BG:SetSprite(Designs[self.db.profile.general.optionsList.Design.BG])
  --Opactity
  BG:SetOpacity(self.db.profile.general.optionsList.Design.fOpacity)
  --Color
  BG:SetBGColor(self.db.profile.general.optionsList.Design.BGColor)
end

function ChargeSortedBank:OnScroll()
	self.wndMain:FindChild("BagGrid"):SetVScrollPos(self.scroll)
end


function ChargeSortedBank:OnWindowMoved( wndHandler, wndControl, nOldLeft, nOldTop, nOldRight, nOldBottom )
	if self:Split(wndControl:GetName(),"_")[1] == "ChargeSortedBankForm" then
		local old = self.db.profile.general.tAnchorOffsetBank
		local new = {wndControl:GetAnchorOffsets()}
		self.db.profile.general.tAnchorOffsetBank = new

		if (old[1]-old[3]) == (new[1]-new[3]) and (old[2]-old[4]) == (new[2]-new[4]) then
			return
		end
		self.db.profile.general.optionsList.General.knBagsWidth = (new[3]-new[1])
		self:ArrangeChildren()
	end

	if wndControl:GetName() == "Options" then
		local new = {wndControl:GetAnchorOffsets()}
		self.db.profile.general.tAnchorOffsetOpt = new
	end
end


function ChargeSortedBank:OnOptionClick( wndHandler, wndControl, eMouseButton )
	if self.wndOptions:IsShown() then
		self.wndOptions:Show(false)
	else
		self.wndOptions:Show(true)
		self:LoadOptions()
		self.wndOptions:ToFront()
	end
end

function ChargeSortedBank:AddNewBag( wndHandler, wndControl, eMouseButton )
	self.wndNewBag:Show(true)
	self.wndNewBag:ToFront()
	self.wndNewBag:FindChild("EditBox"):SetText("Name")
end


function ChargeSortedBank:UpdateSize()
	local Opt = self.db.profile.general.optionsList.General
	local BagGrid = self.wndMain:FindChild("BagGrid"):GetChildren()
	for i,j in pairs(BagGrid) do
		local Bag = j:FindChild("BagGrid"):GetChildren()
		for k,l in pairs(Bag) do
			l:SetAnchorOffsets(0,0,Opt.knSizeIconOption,Opt.knSizeIconOption)
		end
		j:FindChild("BagGrid"):ArrangeChildrenTiles(0)
	end
	self.wndMain:FindChild("BagGrid"):Reposition()
end


function ChargeSortedBank:OnClose( wndHandler, wndControl, eMouseButton )
	wndControl:GetParent():Show(false)
end


function ChargeSortedBank:AdjustNumbers(Bag,Slot)
	for i,j in pairs(Bag:GetChildren()) do
		if(i >= Slot) then
			j:SetName(tostring(i))
		end
	end
end


function ChargeSortedBank:OnSystemBeginDragDrop( wndSource, strType, iData )
	if self.wndMain == nil or not self.wndMain:IsShown() then return end
	if strType ~= "DDBagItem" then return end

	local item = self.RealBag:GetItem(iData)
  if self:IsCustom(item) then
    for i,j in pairs(self.wndMain:FindChild("BagGrid"):GetChildren()) do
        j:FindChild("MouseBlocker"):Show(true)
    end
  else
    for i,j in pairs(self.wndMain:FindChild("BagGrid"):GetChildren()) do
      if self:IsCustomBag(j:GetName()) then
        j:FindChild("MouseBlocker"):Show(true)
      end
    end
  end
	self.DragDrop = item

	Sound.Play(Sound.PlayUI45LiftVirtual)
end


function ChargeSortedBank:OnSystemEndDragDrop(strType, iData)
	if self.wndMain == nil or not self.wndMain:IsShown() then return end
  	for i,j in pairs(self.wndMain:FindChild("BagGrid"):GetChildren()) do
   		j:FindChild("MouseBlocker"):Show(false)
  	end
	if not self.wndMain or not self.wndMain:IsValid() or strType == "DDGuildBankItem" or strType == "DDWarPartyBankItem" or strType == "DDGuildBankItemSplitStack" then
		return -- TODO Investigate if there are other types
	end
	if self.wndMain:IsShown() then
		self:LoadBank()
   		self:LoadSlots()
		local scroll = self.wndMain:FindChild("BagGrid"):GetVScrollPos()
		self:LoadGrid()
		self:ArrangeChildren()
		self.scroll = scroll
		self:RefreshStoreLink()
		self.RealBag:Show(false)
	end
	Sound.Play(Sound.PlayUI46PlaceVirtual)
end

function ChargeSortedBank:OnDragDropMouseBlocker(wndHandler, wndControl, nX, nY, wndSource, strType, nIndex)
	if strType == "DDBagItem" then
    local newBag = wndControl:GetParent():GetName()
    local NewIsCustom = self:IsCustomBag(newBag)
    self:RemoveItemFromCustomBag(self.DragDrop)
    if NewIsCustom then
      if self.db.profile.general.BagList[newBag] == nil then
        self.db.profile.general.BagList[newBag] = {}
      end
      table.insert(self.db.profile.general.BagList[newBag], self:FindSlotNumber(self.DragDrop))
    end
	end
	return false
end

function ChargeSortedBank:OnQueryDragDropMouseBlocker(wndHandler, wndControl, nX, nY, wndSource, strType, nIndex)
	if strType == "DDBagItem" then
		return Apollo.DragDropQueryResult.Accept
	end
	return Apollo.DragDropQueryResult.Ignore
end

function ChargeSortedBank:OnEndDragDropRealBag()
  self:LoadGrid()
  self:ArrangeChildren()
end

function ChargeSortedBank:OnBagDragDropCancel(wndHandler, wndControl, strType, nIndex, eReason)
	if strType ~= "DDBagItem" or eReason == Apollo.DragDropCancelReason.EscapeKey or eReason == Apollo.DragDropCancelReason.ClickedOnNothing then
		return false
	end

	return false
end








